/* ======= Strutture "pproc_str" e "PPROCS" ======= */
/* Sono utili alla gestione dei processi */
/* Le funzioni per la loro gestione si trovano in "pprocs_struct_function.c" */

#define _PPROCS_STRUCT_C

#ifndef _SYS_TYPES_H
#include <sys/types.h>
#endif

#define MAX_PROG_NAME_LENGTH 512

struct pproc_str{
	char proc_name[MAX_PROG_NAME_LENGTH]; 	/*Nome processo*/
	pid_t pid;										/*PID processo*/
	pid_t ppid;										/*PPID processo*/
	struct pproc_str *prec_pproc;				/*Processo precedente nella struttura PPROCS*/
	struct pproc_str *next_pproc;				/*Processo successivo...*/
	int status;										/*Stato del processo: Attivo o Bloccato*/
};

struct PPROCS{
	int pprocs_num;								/*Numero di processi presenti*/
	struct pproc_str *first_pproc;			/*Primo processo*/
	struct pproc_str *last_pproc;				/*Ultimo processo*/
};

typedef struct pproc_str pproc_str;
typedef struct PPROCS PPROCS;
